#include <stdio.h>
#include "sparse_matrix.h"

void print_vector(double *vector, int size) {
    for (int i = 0; i < size; ++i) {
        printf("%lf ", vector[i]);
    }
    printf("\n");
}

void print_sparse_matrix(const SparseMatrix *matrix) {
    if (matrix) {
        printf("%d %d %d\n", matrix->num_nodes, matrix->num_nodes, matrix->num_arcs);
        for (int i = 0; i < matrix->num_arcs; ++i) {
            printf("%d ", matrix->arcs[i].origin + 1);
            printf("%d ", matrix->arcs[i].dest + 1);
            printf("%.10f ", matrix->arcs[i].value);
            printf("\n");
        }
    }
}
