#ifndef SPARSE_MATRIX_H
#define SPARSE_MATRIX_H

typedef struct {
    int origin;
    int dest;
    double value;
} Arc;

typedef struct {
    int num_nodes;
    int num_arcs;
    Arc *arcs;
    int *row_ptr;
} SparseMatrix;

void free_sparse_matrix(SparseMatrix *matrix);
void print_sparse_matrix(const SparseMatrix *matrix);
SparseMatrix* read_sparse_matrix_from_mtx(const char *filename);
void multiply_vector_matrix(const double *vector, const SparseMatrix *matrix, double *result);

#endif
